
function hasNewVersion(newNo, oldNo) {
	var hasNew = false;

	/*if(newNo.length == oldNo.length) {
		var n = newNo.replace(new RegExp("\\.", "gm"), "");
		var o = oldNo.replace(new RegExp("\\.", "gm"), "");
		if(parseInt(n) > parseInt(o)) {
			hasNew = true;
		}
	} else {*/
		var newArr = newNo.split(".", 3);
		var oldArr = oldNo.split(".", 3);
	
		if(parseInt(newArr[0]) > parseInt(oldArr[0])) {
			hasNew = true;
		} else {
			if(parseInt(newArr[0]) == parseInt(oldArr[0])) {
				if(parseInt(newArr[1]) > parseInt(oldArr[1])) {
					hasNew = true;
				} else {
					if(parseInt(newArr[1]) == parseInt(oldArr[1])) {
						if(parseFloat(newArr[2]) > parseFloat(oldArr[2])) {
							hasNew = true;
						}
					}
				}
			}
		}
	//}

	return hasNew;
}

//检查自动更新   
function svn(t) {
	var xhr_svn = new plus.net.XMLHttpRequest();
	xhr_svn.onreadystatechange = function() {
		if(xhr_svn.readyState == 4) {
			if(xhr_svn.status == 200) {
				var res = JSON.parse(xhr_svn.responseText);
				if(res.state == 'yes') {
					var hasNew = hasNewVersion(res.mark, t);
					
					if(hasNew) {
						var btns = ["马上更新"];
						var str = "已有新版本发布，请马上更新！否则会影响业务的正常开展！";

						if(res.force != 'yes') {
							btns.push("稍侯更新");
							str = "有新版本发布了，是否更新？";
						}

						plus.nativeUI.confirm(str, function(e) {

							var upr = (e.index == 0) ? "Y" : "N";
							if(upr == "Y") {
								var wt = plus.nativeUI.showWaiting('下载中，请稍侯...\n0%', {
									back: 'none'
								});

								//mui.showLoading("下载更新中，请勿关闭","div");

								var url = res.url; // 下载文件地址
								var dtask = plus.downloader.createDownload(url, {
									filename: '_doc/update/'
								});
								dtask.addEventListener("statechanged", function(task, status) {
									if(!dtask) {
										return;
									}
									switch(task.state) {
										case 1: // 开始
											console.log("开始下载...");
											break;
										case 2: // 已连接到服务器
											console.log("连接中...");
											break;
										case 3: // 已接收到数据
											//console.log( "下载数据:"+ task.downloadedSize+"/"+task.totalSize);

											var rate = Number(task.downloadedSize) / Number(task.totalSize);
											var str = Number(rate * 100).toFixed(2);
											str += "%";

											wt.setTitle("下载中，请等待...\n" + str);
											break;
										case 4: // 下载完成
											wt.setTitle("请在新打开的窗口中完成安装！");
											var path = dtask.filename;
											plus.runtime.install(path, {force: true}, function() { 
												wt.close();
												plus.nativeUI.alert("更新完成，重启后生效！", function() {  
													plus.runtime.restart();  
												});  
											}, function(e) {  
												mui.alert("更新失败[" + e.code + "]：" + e.message);  
											});
											break;
									}
								});

								dtask.start();
							} else {

							}
						}, "温馨提示", btns);
					} else {
						//TODO: 判断是否有热更新资源
						checkWgtUpdate();
					}
				}
			} else {
				// plus.nativeUI.toast( "网络连接错误！");   
			}
		}
	}

	if(mui.os.ios || mui.os.ipad || mui.os.iphone) {
		
		mui.ajax("https://itunes.apple.com/cn/lookup?id=1314403229", {
			dataType: 'json', //服务器返回json格式数据
			type: 'POST', //HTTP请求类型
			timeout: 0, //15秒超时
			success: function(data) {

				if(data==null || data.results[0]==null || data.results[0].version==null){
					return;
				}
				
				var hasNew = hasNewVersion(data.results[0].version, t);

				if(hasNew) {
					var btns = ["马上更新"];

					plus.nativeUI.confirm("有新版本发布了，请更新！",
						function(e) {
							if(e.index == 0) {
								plus.runtime.openURL("https://itunes.apple.com/cn/app/id1314403229");
							}
						},
						"温馨提示", btns
					);
				}else{
					//判断是否有热更新资源
					checkWgtUpdate();
				}
			},
			error: function(xhr, type, errorThrown) {
				mui.toast('网络连接错误！');
			}
		});

	} else {
		/*if(scanModel == 'PDA'){
			xhr_svn.open("POST", "https://sv.loafish.com/downloads/app/android/erp/pda/update4android.json");	
		}else{*/
			var n = plus.os.version;
			var arr = n.split(".");
			if(parseInt(arr[0]) < 8) { //安卓8.0以下版本的更新
				xhr_svn.open("POST", "https://sv.loafish.com/downloads/app/android/erp/6/update4android.json");
			} else {
				xhr_svn.open("POST", "https://sv.loafish.com/downloads/app/android/update4android.json");
			}
		//}
	}

	xhr_svn.send();
}

function checkWgtUpdate() {
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		
		var xhr = new plus.net.XMLHttpRequest();
		xhr.onreadystatechange = function() {
			if(xhr.readyState == 4) {
				if(xhr.status == 200) {
					
					var res = JSON.parse(xhr.responseText);
					if(res.state == 'yes') {
						var hasNew = hasNewVersion(res.mark, inf.version);
						if(hasNew) {
							plus.nativeUI.confirm("应用现在有新的版本可供更新！", function(e) {
								
								var upr = (e.index == 0) ? "Y" : "N";
								if(upr == "Y") {
									var url = res.wgt_url;
									if(res.mode == 'wgtu' ){
										url = res.wgtu_url;
									}
									downWgt(url);
								}
							}, "升级提示", ["升级"]);
								
						}
					}
					
				}
			}
		};
		
		if(mui.os.ios || mui.os.ipad || mui.os.iphone) {
			xhr.open("POST", "https://sv.loafish.com/downloads/app/ios/erp/update4wgt.json");
		}else{
			xhr.open("POST", "https://sv.loafish.com/downloads/app/android/erp/update4wgt.json");
		}
		
		xhr.send();
	});
}

function downWgt(url) {
	
	var wt = plus.nativeUI.showWaiting('下载中，请稍侯...\n0%', {
		back: 'none'
	});
	var dtask = plus.downloader.createDownload(url, {
		filename: "_downloads/"
	});
	dtask.addEventListener("statechanged", function(task, status) {
		if(!dtask) {
			return;
		}
		switch(task.state) {
			case 1: // 开始
				//console.log("开始下载...");
				break;
			case 2: // 已连接到服务器
				//console.log("链接到服务器...");
				break;
			case 3: // 已接收到数据
				//console.log( "下载数据:"+ task.downloadedSize+"/"+task.totalSize);
	
				var rate = Number(task.downloadedSize) / Number(task.totalSize);
				var str = Number(rate * 100).toFixed(2);
				str += "%";
	
				wt.setTitle("下载中，请等待...\n" + str);
				break;
			case 4: // 下载完成
			
				var path = dtask.filename;
				plus.runtime.install(path, {force: true}, function() { 
					wt.close();
					plus.nativeUI.alert("升级完成，重启后生效！", function() {  
						plus.runtime.restart();  
					});  
				}, function(e) {  
					mui.alert("更新失败[" + e.code + "]：" + e.message);  
				});
				break;
		}
	});
	dtask.start();
};